#include                <unistd.h>
#include                <string.h>
#include                <stdlib.h>
#include                <dlfcn.h>
#include                <time.h>
#include <stdio.h>
#include <sys/time.h>
#include <pthread.h>
#include		"tap.h"
#include		"libFireBird.h"
#include    "TMSCommander.h" //v1.3

#define PROGRAM_NAME	"StartFTPd"
#define VERSION			"V1.3"
#define D(x)			;
#define PORT			"88"

TAP_ID				(0x8E0cffff);
TAP_PROGRAM_NAME	(PROGRAM_NAME" "VERSION);
TAP_AUTHOR_NAME		("srupprecht & xyzzyx");
TAP_DESCRIPTION		("Starts ftpd on port " PORT " (anon login)");
TAP_ETCINFO			(__DATE__);

int  svcType, svcNum;
bool svcAlive;

static dword TMSCommander_handler(dword param1); //v1.3
dword TAP_EventHandler(word event, dword param1, dword param2);
int TAP_Main(void);

// TMSCommander_handler //v1.3
static dword TMSCommander_handler(dword param1)
{
	switch (param1)
	{
		case TMSCMDR_Capabilities:
			return (dword)(TMSCMDR_CanBeStopped);

		case TMSCMDR_Stop:
		//Exit your TAP
			system("sh /mnt/hd/ProgramFiles/stopftpd.sh");
			TAP_Exit(); 
			return TMSCMDR_OK;

		case TMSCMDR_Exiting:
		//TMSCommander is exiting - do you want to do anything?
			return TMSCMDR_OK;

		default:
		//unknown TMSCommander function
			return TMSCMDR_UnknownFunction;
	}
}

dword TAP_EventHandler(word event, dword param1, dword param2)
{
	static int done = 0;
	
	(void) param2;

  if (event == EVT_TMSCommander) //v1.3
		return TMSCommander_handler(param1); //v1.3

	if (event == EVT_STOP && !done)
	{
		system("sh /mnt/hd/ProgramFiles/stopftpd.sh");
		done = 1;
		TAP_Exit(); //v1.3
	}  

	return param1;
}

int TAP_Main(void)
{
	FILE *fp;

	svcAlive = TRUE; //v1.3

	if ((fp = fopen("/mnt/hd/ProgramFiles/startftpd.sh", "w")))
	{
		fprintf(fp, "if [ ! \"$(pidof tcpsvd)\" ]; then\n" \
					"pwd=$PWD\n" \
					"cd /mnt/hd/ProgramFiles/\n" \
					"if [ ! -x tcpsvd ]; then ln -s busybox tcpsvd; fi\n" \
					"./tcpsvd -vE 0.0.0.0 " PORT " ./busybox ftpd -w -t 86400 -T 86400 /mnt/hd &\n" \
					"cd $pwd\n" \
					"else\n" \
					"echo \"tcpsvd is already running!\"\n" \
					"fi\n");
//				"./tcpsvd -vE 0.0.0.0 " PORT " ./busybox ftpd -w /mnt/hd &\n"  //v1.3 timeouts set to 86400 (24h) by using -t and -T
		fclose(fp);

		//v1.3 additional script for manual start of an FTP Daemon for root
		if ((fp = fopen("/mnt/hd/ProgramFiles/startftpd_root.sh", "w")))
		{
			fprintf(fp, "if [ ! \"$(pidof tcpsvd)\" ]; then\n" \
						"pwd=$PWD\n" \
						"cd /mnt/hd/ProgramFiles/\n" \
						"if [ ! -x tcpsvd ]; then ln -s busybox tcpsvd; fi\n" \
						"./tcpsvd -vE 0.0.0.0 " PORT " ./busybox ftpd -w -t 86400 -T 86400 / &\n" \
						"cd $pwd\n" \
						"else\n" \
						"echo \"tcpsvd is already running!\"\n" \
						"fi\n");
			fclose(fp);
		}

		if ((fp = fopen("/mnt/hd/ProgramFiles/stopftpd.sh", "w")))
		{
			fprintf(fp, "if [ ! \"$(pidof tcpsvd)\" ]; then\n" \
						"echo \"tcpsvd is not running!\"\n" \
						"else\n" \
						"pkill -f ftpd\n" \
						"count=3\nwhile [ \"$(pidof tcpsvd)\" ]; do sleep 1\ncount=$[$count-1]\nif [ $count -le 0 ]; then break; fi\ndone\n" \
						"fi\n" );
//					"killall tcpsvd\n" //v1.3 changed to pkill -f ftpd
			fclose(fp);

			system("chmod +x /mnt/hd/ProgramFiles/busybox /mnt/hd/ProgramFiles/startftpd.sh /mnt/hd/ProgramFiles/startftpd_root.sh /mnt/hd/ProgramFiles/stopftpd.sh"); //v1.3 changed

			system("sh /mnt/hd/ProgramFiles/startftpd.sh");

			return 1;
		}
	}
	
	return 0;
}
